-- main.lua  for kernal.love - an edge detection kernal

require 'colors'
require 'shortcuts'
require "kernal3"

function love.load()
	love.graphics.setBackgroundColor( 255, 255, 255 )

	ker={
		{{1, 2,  1}, {0, 0, 0}, {-1, -2, -1}},	-- Sobel (modified)
		{{-1,-1,-1},{-1,8,-1},{-1,-1,-1}},	-- Laplacian8
		{{1/9,1/9,1/9},{1/9,1/9,1/9},{1/9,1/9,1/9}}, -- blur
		{{-2,0,0},{0,0,0},{0,2,0}},		-- gradian
		{{ 0,0,0},{0,1,0},{0,0,0}}		-- none
		}
	names = {"Sobel","Laplacian8","Blur","Gradian","no"}
	img		= gr.newImage( "London.jpg" )
	local h, w = img:getHeight(), img:getWidth()
	kernal:send( 'pixel_size', { 1/w, 1/h } )
	sel = 5
	kernal:send( 'ker', ker[sel] )
	h, w = img:getHeight(), img:getWidth()
	canvas1 = love.graphics.newCanvas( w, h )
	canvas2 = love.graphics.newCanvas( w, h )
	show 	= { sobel	= true}
	gr.setFont( gr.newFont( 16 ) )
	updateEffects()
	end

function love.update( dt )
	end

function love.draw()
	if sel == 5 then
		addText( canvas1 )
		gr.draw( canvas1 )
		else
		gr.draw( canvas2 )
		end
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push('quit')			end
	if key == 's'		then sel=sel<#names and sel+1 or 1 kernal:send('ker',ker[sel]) end--show.sobel		= not show.sobel		end
	updateEffects()
	end

function updateEffects()	-- creates canvas3 containing image with effects
	copyCanvas( img, canvas1 )				-- img > canvas1
	addEffect( kernal, canvas1, canvas2 )	-- canvas1 > canvas2
	addText( canvas2 )
	end

function addText( canvas )
	gr.setCanvas( canvas )				-- add setting display
		gr.setColor( to "black" )
		gr.rectangle( 'fill', 0, 475, 320, 25 )
		gr.setColor( to "red" )
		gr.print( names[sel].." effect: ".."<s> key to change", 10, 475 )
		gr.setColor( to "white" )
	gr.setCanvas(  )
	end

function addEffect( effect, sourceCanvas, destCanvas )
	gr.setPixelEffect( effect )
	destCanvas:clear()
	gr.setCanvas( destCanvas )
	--gr.setColor(255,0,0,255)
	gr.draw( sourceCanvas )
	gr.setCanvas()
	gr.setPixelEffect()
	end

function copyCanvas( sourceCanvas, destCanvas )
	gr.setCanvas( destCanvas )
	gr.draw( sourceCanvas )
	gr.setCanvas()
	end
